//+--------------------------------------------------------------------------------------+
//|                                                                  Autocorrelation.mq4 |
//|                                                               Copyright  2009, gpwr |
//+--------------------------------------------------------------------------------------+
#property copyright "Copyright  2009, gpwr"
#property indicator_chart_window
//#property indicator_buffers 1
//#property indicator_color1 White
//#property indicator_width1 1

int init()
{
   //IndicatorBuffers(0);
   return(0);
}

int deinit(){return(0);}

int start()
{
// Calculate differences
   double x[];
   int n=Bars; // n=Bars-1 for differences
   ArrayResize(x,n);
   for(int i=0;i<n;i++) x[i]=Open[i]; // x[i]=Open[i]-Open[i+1];
   
// Calculate mean - first moment - E{x}
   double m1=0.0;
   for(i=0;i<n;i++) m1+=x[i];
   m1/=n;
   
// Subtract mean from the data
   for(i=0;i<n;i++) x[i]-=m1;
   
// Calculate std deviation - second moment - E{x^2}
   double m2=0.0;
   for(i=0;i<n;i++) m2+=x[i]*x[i];
   m2/=n;

// Normalize data by std deviation
   double norm=MathSqrt(m2);
   for(i=0;i<n;i++) x[i]/=norm;
   
// Calculate 4th and 6th moments - E{x^4}
   double m4=0.0;
   double m6=0.0;
   for(i=0;i<n;i++)
   {
      m4+=MathPow(x[i],4);
      m6+=MathPow(x[i],6);
   }
   m4/=n;
   m6/=n;
   Print("Bars=",Bars," m4=",m4," m6=",m6);

   return(0); 
}