//+--------------------------------------------------------------------------------------+
//|                                                                Stationarity_test.mq4 |
//|                                                               Copyright  2009, gpwr |
//+--------------------------------------------------------------------------------------+
#property copyright "Copyright  2009, gpwr"
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_width1 1
#property indicator_color2 Yellow
#property indicator_width2 1

//Indicator buffers
double m1[],m2[];

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,m1);
   SetIndexBuffer(1,m2);
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   IndicatorShortName("Moments");  
   return(0);
}

int deinit(){return(0);}

int start()
{
// Calculate differences
   double x[];
   int n=Bars-1;
   int n2=n/2;
   int dn=n-n2;
   ArrayResize(x,n);
   for(int i=0;i<n;i++) x[i]=Open[i]-Open[i+1];
   
// Calculate mean for the first half of data
   double mean=0.0;
   for(i=n2;i<n;i++) mean+=x[i];
   mean/=dn;
   
// Subtract mean from the data
   for(i=0;i<n;i++) x[i]-=mean;
   
// Calculate std deviation for the first half of data
   double stdDev=0.0;
   for(i=n2;i<n;i++) stdDev+=x[i]*x[i];
   stdDev=MathSqrt(stdDev/dn);

// Normalize data by std deviation
   for(i=0;i<n;i++) x[i]/=stdDev;
   
// Calculate mean for the rest of the data
   ArrayInitialize(m1,EMPTY_VALUE);
   ArrayInitialize(m2,EMPTY_VALUE);
   double m1sum=0.0;
   double m2sum=0.0;
   for(i=n2;i>=0;i--)
   {
      if(i==n2)
      {
         for(int k=n2;k<n;k++)
         {
            m1sum+=x[k];
            m2sum+=x[k]*x[k];
         }
      }
      else
      {
         m1sum+=x[i]-x[i+dn];
         m2sum+=x[i]*x[i]-x[i+dn]*x[i+dn];
      }
      m1[i]=m1sum/dn;
      m2[i]=m2sum/dn;
      if(m1[i]>100 || m1[i]<-100) m1[i]=EMPTY_VALUE;
      if(m2[i]>100 || m2[i]<-100) m2[i]=EMPTY_VALUE;
   }

   return(0); 
}